// Sample07.cpp : Defines the entry point for the console application.
//

#define _CRT_SECURE_NO_WARNINGS

#include "stdafx.h"

static
VOID
TC_CALLCONV
EvtLinkStatusChange(
					TC_INSTANCE instance, 
					TC_LINK_INFO linkInfo, 
					PVOID context);


int main(int argc, char* argv[])
{
	PTC_PORT	portList;
	ULONG		numPorts;
	TC_STATUS	status;
	ULONG		i;
	ULONG		numPort;
	TC_PORT	port;
	TC_INSTANCE instance;

	UNUSED(argc);
	UNUSED(argv);

	status = TcQueryPortList(&portList, &numPorts);

	if (status != TC_SUCCESS)
	{
		printf("Cannot retrieve port list, %s\n", TcStatusGetString(status));
		return -1;
	}

	if (numPorts == 0)
	{
		printf("No ports available.\n");
		return 0;
	}
	
	do
	{
		for (i = 0; i < numPorts; i++)
		{
			if (TcPortGetType(portList[i]) == TC_PORT_TYPE_PHYSICAL)
			{
				printf("%u) %s (%s)\n", i, TcPortGetDescription(portList[i]), TcPortGetName(portList[i]));
			}
		}

		printf("\nPort number? ");
	}
	while((scanf("%u", &numPort) == 0 ) || (numPort >= numPorts) || (TcPortGetType(portList[numPort]) != TC_PORT_TYPE_PHYSICAL));

	port = portList[numPort];

	status = TcInstanceOpenByPort(port, &instance);

	TcFreePortList(portList);

	if (status != TC_SUCCESS)
	{
		printf("Cannot open port, %08x\n", status);
		return -1;
	}

	status = TcInstanceRegisterEvtLinkStatusChange(instance, EvtLinkStatusChange, NULL);
	if (status != TC_SUCCESS)
	{
		printf("Cannot register link status change notification handler, %08x\n", status);
	}

	printf("Press a key to exit...\n");

	while(!_kbhit())
	{
#ifdef _WIN32
		Sleep(100);
#else
		usleep(100*1000);
#endif
	}

	TcInstanceClose(instance);
	return 0;

}

VOID
EvtLinkStatusChange(
					TC_INSTANCE instance, 
					TC_LINK_INFO linkInfo, 
					PVOID context)
{
	printf("Link status change on instance %p\n", instance);
	printf("Context = %p\n", context);

	if (linkInfo.LinkUp)
	{
		printf("Link is now UP.\n");
		printf("Link speed is %u\n", linkInfo.LinkSpeed);
		printf("Link duplex is ");
		switch(linkInfo.DuplexType)
		{
		case TC_FULL_DUPLEX: printf("FULL\n"); break;
		case TC_HALF_DUPLEX: printf("HALF\n"); break;
		default: printf("Unknown\n");
		}
	}
	else
	{
		printf("Link is now DOWN.\n");
	}
}

